diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-80211e-txop.cc ns-3.42/examples/wireless/wifi-80211e-txop.cc
--- ns-3.41/examples/wireless/wifi-80211e-txop.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-80211e-txop.cc	2024-05-29 15:29:46.912073100 -0700
@@ -55,7 +55,7 @@
 //
 // The user can select the distance between the stations and the APs, can enable/disable the RTS/CTS
 // mechanism and can choose the payload size and the simulation duration. Example: ./ns3 run
-// "wifi-80211e-txop --distance=10 --simulationTime=20 --payloadSize=1000"
+// "wifi-80211e-txop --distance=10 --simulationTime=20s --payloadSize=1000"
 //
 // The output prints the throughput measured for the 4 cases/networks described above. When TXOP is
 // enabled, results show increased throughput since the channel is granted for a longer duration.
@@ -94,16 +94,16 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t payloadSize = 1472; // bytes
-    double simulationTime = 10;  // seconds
-    double distance = 5;         // meters
-    bool enablePcap = false;
-    bool verifyResults = false; // used for regression
-    Time txopLimit = MicroSeconds(4096);
+    uint32_t payloadSize{1472}; // bytes
+    Time simulationTime{"10s"};
+    double distance{5}; // meters
+    bool enablePcap{false};
+    bool verifyResults{false}; // used for regression
+    Time txopLimit{"4096us"};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("payloadSize", "Payload size in bytes", payloadSize);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -296,74 +296,74 @@
     UdpServerHelper serverA(port);
     ApplicationContainer serverAppA = serverA.Install(wifiApNodes.Get(0));
     serverAppA.Start(Seconds(0.0));
-    serverAppA.Stop(Seconds(simulationTime + 1));
+    serverAppA.Stop(simulationTime + Seconds(1.0));
 
     InetSocketAddress destA(ApInterfaceA.GetAddress(0), port);
-    destA.SetTos(0x70); // AC_BE
 
     OnOffHelper clientA("ns3::UdpSocketFactory", destA);
     clientA.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
     clientA.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
     clientA.SetAttribute("DataRate", StringValue("100000kb/s"));
     clientA.SetAttribute("PacketSize", UintegerValue(payloadSize));
+    clientA.SetAttribute("Tos", UintegerValue(0x70)); // AC_BE
 
     ApplicationContainer clientAppA = clientA.Install(wifiStaNodes.Get(0));
     clientAppA.Start(Seconds(1.0));
-    clientAppA.Stop(Seconds(simulationTime + 1));
+    clientAppA.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverB(port);
     ApplicationContainer serverAppB = serverB.Install(wifiApNodes.Get(1));
     serverAppB.Start(Seconds(0.0));
-    serverAppB.Stop(Seconds(simulationTime + 1));
+    serverAppB.Stop(simulationTime + Seconds(1.0));
 
     InetSocketAddress destB(ApInterfaceB.GetAddress(0), port);
-    destB.SetTos(0x70); // AC_BE
 
     OnOffHelper clientB("ns3::UdpSocketFactory", destB);
     clientB.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
     clientB.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
     clientB.SetAttribute("DataRate", StringValue("100000kb/s"));
     clientB.SetAttribute("PacketSize", UintegerValue(payloadSize));
+    clientB.SetAttribute("Tos", UintegerValue(0x70)); // AC_BE
 
     ApplicationContainer clientAppB = clientB.Install(wifiStaNodes.Get(1));
     clientAppB.Start(Seconds(1.0));
-    clientAppB.Stop(Seconds(simulationTime + 1));
+    clientAppB.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverC(port);
     ApplicationContainer serverAppC = serverC.Install(wifiApNodes.Get(2));
     serverAppC.Start(Seconds(0.0));
-    serverAppC.Stop(Seconds(simulationTime + 1));
+    serverAppC.Stop(simulationTime + Seconds(1.0));
 
     InetSocketAddress destC(ApInterfaceC.GetAddress(0), port);
-    destC.SetTos(0xb8); // AC_VI
 
     OnOffHelper clientC("ns3::UdpSocketFactory", destC);
     clientC.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
     clientC.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
     clientC.SetAttribute("DataRate", StringValue("100000kb/s"));
     clientC.SetAttribute("PacketSize", UintegerValue(payloadSize));
+    clientC.SetAttribute("Tos", UintegerValue(0xb8)); // AC_VI
 
     ApplicationContainer clientAppC = clientC.Install(wifiStaNodes.Get(2));
     clientAppC.Start(Seconds(1.0));
-    clientAppC.Stop(Seconds(simulationTime + 1));
+    clientAppC.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverD(port);
     ApplicationContainer serverAppD = serverD.Install(wifiApNodes.Get(3));
     serverAppD.Start(Seconds(0.0));
-    serverAppD.Stop(Seconds(simulationTime + 1));
+    serverAppD.Stop(simulationTime + Seconds(1.0));
 
     InetSocketAddress destD(ApInterfaceD.GetAddress(0), port);
-    destD.SetTos(0xb8); // AC_VI
 
     OnOffHelper clientD("ns3::UdpSocketFactory", destD);
     clientD.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
     clientD.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
     clientD.SetAttribute("DataRate", StringValue("100000kb/s"));
     clientD.SetAttribute("PacketSize", UintegerValue(payloadSize));
+    clientD.SetAttribute("Tos", UintegerValue(0xb8)); // AC_VI
 
     ApplicationContainer clientAppD = clientD.Install(wifiStaNodes.Get(3));
     clientAppD.Start(Seconds(1.0));
-    clientAppD.Stop(Seconds(simulationTime + 1));
+    clientAppD.Stop(simulationTime + Seconds(1.0));
 
     if (enablePcap)
     {
@@ -377,18 +377,18 @@
         phy.EnablePcap("STA_D", staDeviceD.Get(0));
     }
 
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
     /* Show results */
-    uint64_t totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
+    double totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
+    double totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
+    double totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
+    double totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
 
     Simulator::Destroy();
 
-    double throughput = totalPacketsThroughA * payloadSize * 8 / (simulationTime * 1000000.0);
+    auto throughput = totalPacketsThroughA * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "AC_BE with default TXOP limit (0ms): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 28 || throughput > 29))
@@ -397,7 +397,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughB * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughB * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "AC_BE with non-default TXOP limit (4.096ms): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 36.5 || throughput > 37))
@@ -415,7 +415,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughC * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughC * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "AC_VI with default TXOP limit (4.096ms): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 36.5 || throughput > 37.5))
@@ -433,7 +433,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughD * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughD * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "AC_VI with non-default TXOP limit (0ms): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 31.5 || throughput > 32.5))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-80211n-mimo.cc ns-3.42/examples/wireless/wifi-80211n-mimo.cc
--- ns-3.41/examples/wireless/wifi-80211n-mimo.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-80211n-mimo.cc	2024-05-29 15:29:46.912073100 -0700
@@ -41,6 +41,7 @@
 #include "ns3/config.h"
 #include "ns3/double.h"
 #include "ns3/gnuplot.h"
+#include "ns3/ht-phy.h"
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/ipv4-global-routing-helper.h"
@@ -70,17 +71,17 @@
         "HtMcs24", "HtMcs25", "HtMcs26", "HtMcs27", "HtMcs28", "HtMcs29", "HtMcs30", "HtMcs31",
     };
 
-    bool udp = true;
-    double simulationTime = 5; // seconds
-    double frequency = 5.0;    // whether 2.4 or 5.0 GHz
-    double step = 5;           // meters
-    bool shortGuardInterval = false;
-    bool channelBonding = false;
-    bool preambleDetection = true;
+    bool udp{true};
+    Time simulationTime{"5s"};
+    double frequency{5.0}; // whether 2.4 or 5.0 GHz
+    double step{5};        // meters
+    bool shortGuardInterval{false};
+    bool channelBonding{false};
+    bool preambleDetection{true};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("step", "Granularity of the results to be plotted in meters", step);
-    cmd.AddValue("simulationTime", "Simulation time per step (in seconds)", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time per step", simulationTime);
     cmd.AddValue("channelBonding",
                  "Enable/disable channel bonding (channel width = 20 MHz if false, channel width = "
                  "40 MHz if true)",
@@ -213,6 +214,10 @@
             apNodeInterface = address.Assign(apDevice);
 
             /* Setting applications */
+            const auto maxLoad = HtPhy::GetDataRate(i,
+                                                    channelBonding ? 40 : 20,
+                                                    shortGuardInterval ? 400 : 800,
+                                                    nStreams);
             ApplicationContainer serverApp;
             if (udp)
             {
@@ -221,15 +226,16 @@
                 UdpServerHelper server(port);
                 serverApp = server.Install(wifiStaNode.Get(0));
                 serverApp.Start(Seconds(0.0));
-                serverApp.Stop(Seconds(simulationTime + 1));
+                serverApp.Stop(simulationTime + Seconds(1.0));
+                const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                 UdpClientHelper client(staNodeInterface.GetAddress(0), port);
                 client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-                client.SetAttribute("Interval", TimeValue(Time("0.00001"))); // packets/s
+                client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
                 client.SetAttribute("PacketSize", UintegerValue(payloadSize));
                 ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
                 clientApp.Start(Seconds(1.0));
-                clientApp.Stop(Seconds(simulationTime + 1));
+                clientApp.Stop(simulationTime + Seconds(1.0));
             }
             else
             {
@@ -239,7 +245,7 @@
                 PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
                 serverApp = packetSinkHelper.Install(wifiStaNode.Get(0));
                 serverApp.Start(Seconds(0.0));
-                serverApp.Stop(Seconds(simulationTime + 1));
+                serverApp.Stop(simulationTime + Seconds(1.0));
 
                 OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
                 onoff.SetAttribute("OnTime",
@@ -247,34 +253,34 @@
                 onoff.SetAttribute("OffTime",
                                    StringValue("ns3::ConstantRandomVariable[Constant=0]"));
                 onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-                onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+                onoff.SetAttribute("DataRate", DataRateValue(maxLoad));
                 AddressValue remoteAddress(InetSocketAddress(staNodeInterface.GetAddress(0), port));
                 onoff.SetAttribute("Remote", remoteAddress);
                 ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
                 clientApp.Start(Seconds(1.0));
-                clientApp.Stop(Seconds(simulationTime + 1));
+                clientApp.Stop(simulationTime + Seconds(1.0));
             }
 
             Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-            Simulator::Stop(Seconds(simulationTime + 1));
+            Simulator::Stop(simulationTime + Seconds(1.0));
             Simulator::Run();
 
             double throughput = 0;
             if (udp)
             {
                 // UDP
-                uint64_t totalPacketsThrough =
+                double totalPacketsThrough =
                     DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
-                throughput =
-                    totalPacketsThrough * payloadSize * 8 / (simulationTime * 1000000.0); // Mbit/s
+                throughput = totalPacketsThrough * payloadSize * 8 /
+                             simulationTime.GetMicroSeconds(); // Mbit/s
             }
             else
             {
                 // TCP
-                uint64_t totalPacketsThrough =
+                double totalPacketsThrough =
                     DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
-                throughput = totalPacketsThrough * 8 / (simulationTime * 1000000.0); // Mbit/s
+                throughput = totalPacketsThrough * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
             }
             dataset.Add(d, throughput);
             std::cout << throughput << " Mbit/s" << std::endl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-aggregation.cc ns-3.42/examples/wireless/wifi-aggregation.cc
--- ns-3.41/examples/wireless/wifi-aggregation.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-aggregation.cc	2024-05-29 15:29:46.912073100 -0700
@@ -59,7 +59,7 @@
 //
 // The user can select the distance between the stations and the APs and can enable/disable the
 // RTS/CTS mechanism. Example: ./ns3 run "wifi-aggregation --distance=10 --enableRts=0
-// --simulationTime=20"
+// --simulationTime=20s"
 //
 // The output prints the throughput measured for the 4 cases/networks described above. When default
 // aggregation parameters are enabled, the maximum A-MPDU size is 65 kB and the throughput is
@@ -82,17 +82,17 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t payloadSize = 1472; // bytes
-    double simulationTime = 10;  // seconds
-    double distance = 5;         // meters
-    bool enableRts = false;
-    bool enablePcap = false;
-    bool verifyResults = false; // used for regression
+    uint32_t payloadSize{1472}; // bytes
+    Time simulationTime{"10s"};
+    double distance{5}; // meters
+    bool enableRts{false};
+    bool enablePcap{false};
+    bool verifyResults{false}; // used for regression
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("payloadSize", "Payload size in bytes", payloadSize);
     cmd.AddValue("enableRts", "Enable or disable RTS/CTS", enableRts);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -282,7 +282,7 @@
     UdpServerHelper serverA(port);
     ApplicationContainer serverAppA = serverA.Install(wifiStaNodes.Get(0));
     serverAppA.Start(Seconds(0.0));
-    serverAppA.Stop(Seconds(simulationTime + 1));
+    serverAppA.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientA(StaInterfaceA.GetAddress(0), port);
     clientA.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -291,12 +291,12 @@
 
     ApplicationContainer clientAppA = clientA.Install(wifiApNodes.Get(0));
     clientAppA.Start(Seconds(1.0));
-    clientAppA.Stop(Seconds(simulationTime + 1));
+    clientAppA.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverB(port);
     ApplicationContainer serverAppB = serverB.Install(wifiStaNodes.Get(1));
     serverAppB.Start(Seconds(0.0));
-    serverAppB.Stop(Seconds(simulationTime + 1));
+    serverAppB.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientB(StaInterfaceB.GetAddress(0), port);
     clientB.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -305,12 +305,12 @@
 
     ApplicationContainer clientAppB = clientB.Install(wifiApNodes.Get(1));
     clientAppB.Start(Seconds(1.0));
-    clientAppB.Stop(Seconds(simulationTime + 1));
+    clientAppB.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverC(port);
     ApplicationContainer serverAppC = serverC.Install(wifiStaNodes.Get(2));
     serverAppC.Start(Seconds(0.0));
-    serverAppC.Stop(Seconds(simulationTime + 1));
+    serverAppC.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientC(StaInterfaceC.GetAddress(0), port);
     clientC.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -319,12 +319,12 @@
 
     ApplicationContainer clientAppC = clientC.Install(wifiApNodes.Get(2));
     clientAppC.Start(Seconds(1.0));
-    clientAppC.Stop(Seconds(simulationTime + 1));
+    clientAppC.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverD(port);
     ApplicationContainer serverAppD = serverD.Install(wifiStaNodes.Get(3));
     serverAppD.Start(Seconds(0.0));
-    serverAppD.Stop(Seconds(simulationTime + 1));
+    serverAppD.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientD(StaInterfaceD.GetAddress(0), port);
     clientD.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -333,7 +333,7 @@
 
     ApplicationContainer clientAppD = clientD.Install(wifiApNodes.Get(3));
     clientAppD.Start(Seconds(1.0));
-    clientAppD.Stop(Seconds(simulationTime + 1));
+    clientAppD.Stop(simulationTime + Seconds(1.0));
 
     if (enablePcap)
     {
@@ -347,18 +347,18 @@
         phy.EnablePcap("STA_D", staDeviceD.Get(0));
     }
 
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
     // Show results
-    uint64_t totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
+    double totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
+    double totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
+    double totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
+    double totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
 
     Simulator::Destroy();
 
-    double throughput = totalPacketsThroughA * payloadSize * 8 / (simulationTime * 1000000.0);
+    auto throughput = totalPacketsThroughA * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Throughput with default configuration (A-MPDU aggregation enabled, 65kB): "
               << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 59.0 || throughput > 60.0))
@@ -367,7 +367,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughB * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughB * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Throughput with aggregation disabled: " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 30 || throughput > 31))
     {
@@ -375,7 +375,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughC * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughC * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Throughput with A-MPDU disabled and A-MSDU enabled (8kB): " << throughput
               << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 51 || throughput > 52))
@@ -384,7 +384,7 @@
         exit(1);
     }
 
-    throughput = totalPacketsThroughD * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughD * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Throughput with A-MPDU enabled (32kB) and A-MSDU enabled (4kB): " << throughput
               << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 58 || throughput > 59))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-ap.py ns-3.42/examples/wireless/wifi-ap.py
--- ns-3.41/examples/wireless/wifi-ap.py	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-ap.py	2024-05-29 15:29:46.912073100 -0700
@@ -93,16 +93,16 @@
 
 
 def main(argv):
-    ns.core.CommandLine().Parse(argv)
+    ns.CommandLine().Parse(argv)
 
-    ns.network.Packet.EnablePrinting()
+    ns.Packet.EnablePrinting()
 
-    wifi = ns.wifi.WifiHelper()
-    mobility = ns.mobility.MobilityHelper()
-    stas = ns.network.NodeContainer()
-    ap = ns.network.NodeContainer()
+    wifi = ns.WifiHelper()
+    mobility = ns.MobilityHelper()
+    stas = ns.NodeContainer()
+    ap = ns.NodeContainer()
     # NetDeviceContainer staDevs;
-    packetSocket = ns.network.PacketSocketHelper()
+    packetSocket = ns.PacketSocketHelper()
 
     stas.Create(2)
     ap.Create(1)
@@ -111,45 +111,45 @@
     packetSocket.Install(stas)
     packetSocket.Install(ap)
 
-    wifiPhy = ns.wifi.YansWifiPhyHelper()
-    wifiChannel = ns.wifi.YansWifiChannelHelper.Default()
+    wifiPhy = ns.YansWifiPhyHelper()
+    wifiChannel = ns.YansWifiChannelHelper.Default()
     wifiPhy.SetChannel(wifiChannel.Create())
 
-    ssid = ns.wifi.Ssid("wifi-default")
-    wifiMac = ns.wifi.WifiMacHelper()
+    ssid = ns.Ssid("wifi-default")
+    wifiMac = ns.WifiMacHelper()
 
     # setup stas.
     wifiMac.SetType(
         "ns3::StaWifiMac",
         "ActiveProbing",
-        ns.core.BooleanValue(True),
+        ns.BooleanValue(True),
         "Ssid",
-        ns.wifi.SsidValue(ssid),
+        ns.SsidValue(ssid),
     )
     staDevs = wifi.Install(wifiPhy, wifiMac, stas)
     # setup ap.
-    wifiMac.SetType("ns3::ApWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
+    wifiMac.SetType("ns3::ApWifiMac", "Ssid", ns.SsidValue(ssid))
     wifi.Install(wifiPhy, wifiMac, ap)
 
     # mobility.
     mobility.Install(stas)
     mobility.Install(ap)
 
-    ns.core.Simulator.Schedule(ns.core.Seconds(1.0), ns.cppyy.gbl.AdvancePosition, ap.Get(0))
+    ns.Simulator.Schedule(ns.Seconds(1.0), ns.cppyy.gbl.AdvancePosition, ap.Get(0))
 
-    socket = ns.network.PacketSocketAddress()
+    socket = ns.PacketSocketAddress()
     socket.SetSingleDevice(staDevs.Get(0).GetIfIndex())
     socket.SetPhysicalAddress(staDevs.Get(1).GetAddress())
     socket.SetProtocol(1)
 
-    onoff = ns.applications.OnOffHelper("ns3::PacketSocketFactory", socket.ConvertTo())
-    onoff.SetConstantRate(ns.network.DataRate("500kb/s"))
+    onoff = ns.OnOffHelper("ns3::PacketSocketFactory", socket.ConvertTo())
+    onoff.SetConstantRate(ns.DataRate("500kb/s"))
 
-    apps = onoff.Install(ns.network.NodeContainer(stas.Get(0)))
-    apps.Start(ns.core.Seconds(0.5))
-    apps.Stop(ns.core.Seconds(43.0))
+    apps = onoff.Install(ns.NodeContainer(stas.Get(0)))
+    apps.Start(ns.Seconds(0.5))
+    apps.Stop(ns.Seconds(43.0))
 
-    ns.core.Simulator.Stop(ns.core.Seconds(44.0))
+    ns.Simulator.Stop(ns.Seconds(44.0))
 
     #   Config::Connect("/NodeList/*/DeviceList/*/Tx", MakeCallback(&DevTxTrace));
     #   Config::Connect("/NodeList/*/DeviceList/*/Rx", MakeCallback(&DevRxTrace));
@@ -158,8 +158,8 @@
     #   Config::Connect("/NodeList/*/DeviceList/*/Phy/Tx", MakeCallback(&PhyTxTrace));
     #   Config::Connect("/NodeList/*/DeviceList/*/Phy/State", MakeCallback(&PhyStateTrace));
 
-    ns.core.Simulator.Run()
-    ns.core.Simulator.Destroy()
+    ns.Simulator.Run()
+    ns.Simulator.Destroy()
 
     return 0
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-backward-compatibility.cc ns-3.42/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.41/examples/wireless/wifi-backward-compatibility.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-backward-compatibility.cc	2024-05-29 15:29:46.912073100 -0700
@@ -113,17 +113,17 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t payloadSize = 1472; // bytes
-    double simulationTime = 10;  // seconds
-    std::string apVersion = "80211a";
-    std::string staVersion = "80211n_5GHZ";
-    std::string apRaa = "Minstrel";
-    std::string staRaa = "MinstrelHt";
-    bool apHasTraffic = false;
-    bool staHasTraffic = true;
+    uint32_t payloadSize{1472}; // bytes
+    Time simulationTime{"10s"};
+    std::string apVersion{"80211a"};
+    std::string staVersion{"80211n_5GHZ"};
+    std::string apRaa{"Minstrel"};
+    std::string staRaa{"MinstrelHt"};
+    bool apHasTraffic{false};
+    bool staHasTraffic{true};
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("apVersion",
                  "The standard version used by the AP: 80211a, 80211b, 80211g, 80211p, "
                  "80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ",
@@ -204,12 +204,12 @@
     UdpServerHelper apServer(9);
     ApplicationContainer apServerApp = apServer.Install(wifiApNode.Get(0));
     apServerApp.Start(Seconds(0.0));
-    apServerApp.Stop(Seconds(simulationTime + 1));
+    apServerApp.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper staServer(5001);
     ApplicationContainer staServerApp = staServer.Install(wifiStaNode.Get(0));
     staServerApp.Start(Seconds(0.0));
-    staServerApp.Stop(Seconds(simulationTime + 1));
+    staServerApp.Stop(simulationTime + Seconds(1.0));
 
     if (apHasTraffic)
     {
@@ -219,7 +219,7 @@
         apClient.SetAttribute("PacketSize", UintegerValue(payloadSize)); // bytes
         ApplicationContainer apClientApp = apClient.Install(wifiApNode.Get(0));
         apClientApp.Start(Seconds(1.0));
-        apClientApp.Stop(Seconds(simulationTime + 1));
+        apClientApp.Stop(simulationTime + Seconds(1.0));
     }
 
     if (staHasTraffic)
@@ -230,21 +230,21 @@
         staClient.SetAttribute("PacketSize", UintegerValue(payloadSize)); // bytes
         ApplicationContainer staClientApp = staClient.Install(wifiStaNode.Get(0));
         staClientApp.Start(Seconds(1.0));
-        staClientApp.Stop(Seconds(simulationTime + 1));
+        staClientApp.Stop(simulationTime + Seconds(1.0));
     }
 
     Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
-    uint64_t rxBytes;
+    double rxBytes;
     double throughput;
     bool error = false;
     if (apHasTraffic)
     {
         rxBytes = payloadSize * DynamicCast<UdpServer>(staServerApp.Get(0))->GetReceived();
-        throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+        throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
         std::cout << "AP Throughput: " << throughput << " Mbit/s" << std::endl;
         if (throughput == 0)
         {
@@ -254,7 +254,7 @@
     if (staHasTraffic)
     {
         rxBytes = payloadSize * DynamicCast<UdpServer>(apServerApp.Get(0))->GetReceived();
-        throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+        throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
         std::cout << "STA Throughput: " << throughput << " Mbit/s" << std::endl;
         if (throughput == 0)
         {
